
<!DOCTYPE html>
<html lang="en">
	<head>
		<title>MontiSim Visualization</title>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, user-scalable=no, minimum-scale=1.0, maximum-scale=1.0">
		<link rel="stylesheet" href="css/fontawesome/css/font-awesome.min.css"/>
		<link rel="stylesheet" href="css/main.css"/>
        
        <script src="js/vendor/build/three.js"></script>
        
		<script src="js/vendor/BinaryLoader.js"></script>
		<script src="js/vendor/Detector.js"></script>
		<script src="js/vendor/stats.min.js"></script>
		<script src="js/vendor/Car.js"></script>
		<script src="js/vendor/math.min.js"></script>
		<script src="js/vendor/three.orbitcontrols.js"></script>
        
        <!--    SFS2X    -->
        <script src="js/vendor/sfs2x-api-1.7.6.js"></script>

        <!-- Dependencies -->
        <script src="js/vendor/Shape.js"></script>
        <script src="js/vendor/ExtrudeGeometry.js"></script>

        <!--    Additions    -->
        <script src="utils/fileHelper/jszip.js"></script>
		<script src="utils/machineLearning/CarDetectionTrainingData.js"></script>
        
		<!-- Modules -->
		<script src="js/CameraController.js"></script>
		<script src="js/EnvBuilder.js"></script>
		<script src="js/LightController.js"></script>
		<script src="js/RainController.js"></script>
		<script src="js/CarController.js"></script>
		<script src="js/MeshBuilder.js"></script>

        <script src="js/Materials.js"></script>
        <script src="js/CarBuilder.js"></script>

        <script src="js/Server.js"></script>
		<script src="js/WebService.js"></script>
		<script src="js/DataModel.js"></script>
        <!--    HTML components    -->
        <script src="js/NavBar.js"></script>

	</head>

	<body>
        <div id="loader" class="disabled">
            <span>Loading...</span>
        </div>

        <div id="message" class="disabled"></div>
        
		<div class="lbl">
			Controls: <br />
			c - change Camera<br />
			u - Orbit Control<br />
			p - Screenshot<br />
			h - toggle HUD<br />
			l - use Stereo
		</div>

        <div class="powered-by-sfx-container">
            <img class="sfx-logo" src="img/smarfox.png" alt="">
        </div>

		<canvas id="hiddenCanvas"></canvas>
		<canvas id="hiddenCanvasLowRes"></canvas>
        
        <!--    Controls    -->
        <div id="nav-menu"><!-- Dynamic DropDown here --></div>

        <script>
			if ( ! Detector.webgl ) Detector.addGetWebGLMessage();

			var STATS_ENABLED = false;
			var currentCar = null;
			var heightData;
			var planeX = 4096;
			var planeZ = 4096;
			var planeXVerts = 128;
			var planeZVerts = 128;

			var CARS = {};

			var container, stats;

			var camera, hCamera, scene, renderer, rendererH, controls, effect, canvas;

			var m, mi;

			var useStereo = false;
			var dayNightCircle = true;

			var directionalLight;

			var mouseX = 0, mouseY = 0;

			var windowHalfX = window.innerWidth / 2;
			var windowHalfY = window.innerHeight / 2;

			var screenIter = 1;

			var loader = new THREE.BinaryLoader();
			var jsonLoader = new THREE.JSONLoader();
			var tgaLoader = new THREE.TextureLoader();

			var meshArr = [];
			meshArr.trafficLights = [];
			meshArr.pedestrians = [];

			var cameraController = null;
			var carController = new CarController();
			var rainController = new RainController();

			var clock = new THREE.Clock();
			var timeDelta = null;

			var LS_Meshcounter = 0;
			var LS_Dbg = false;
			var LS_flag = true;

			var stereoCameraBaseline = 2;
            
            var ENV_BUILDER = null;
            var MESH_BUILDER = null;
            
            var USER = {};
            
            var INIT_CAR;

			init();

			function init() {
				container = document.createElement( 'div' );
				document.body.appendChild( container );

				// CANVAS

				hCanvasLowRes = document.getElementById("hiddenCanvasLowRes");
				hCanvasLowRes.width = 600;
				hCanvasLowRes.height = 300;
				hCanvasLowRes.style.left = "0px";
				hCanvasLowRes.style.top = "0px";
				hCanvasLowRes.style.position = "absolute";
				hCanvasLowRes.style.display = "none";

				hCanvas = document.getElementById("hiddenCanvas");
				hCanvas.width = window.innerWidth;
				hCanvas.height = window.innerHeight;
				hCanvas.style.left = "0px";
				hCanvas.style.top = "0px";
				hCanvas.style.position = "absolute";
				hCanvas.style.display = "none";

				// CAMERAS
				camera = new THREE.PerspectiveCamera( 70, window.innerWidth / window.innerHeight, 100, 15000 );
				camera.projectionMatrix.scale(new THREE.Vector3(-1, 1, 1));

				hCamera = new THREE.PerspectiveCamera( 70, window.innerWidth / window.innerHeight, 10, 10000 );

				// ORBIT CONTROL

				controls = new THREE.OrbitControls(camera);
				controls.minDistance = 0;
				controls.maxDistance = Infinity;
				controls.enabled = true;
				controls.target.set(90000, 50, 72000);

				// SCENE

				var textureCube = new THREE.CubeTextureLoader()
                //skybox background
					.setPath( 'img/textures/Background/')
					.load( [ 'px.jpg', 'nx.jpg', 'py.jpg', 'ny.jpg', 'pz.jpg', 'nz.jpg' ] );

				scene = new THREE.Scene();

				//Add fog
				scene.fog = new THREE.Fog( 0x808080, 2500, 8000 );
				scene.background = textureCube; //Fog does not work with background!
                
                var ENV_BUILDER = new EnvBuilder(tgaLoader, scene);
                var MESH_BUILDER = new MeshBuilder(jsonLoader, tgaLoader, scene, meshArr);

				var carBuilder = new CarBuilder(textureCube);

				//attach CameraController
				cameraController = new CameraController(camera);
				cameraController.setCameraPosition(cameraController.DEFAULT_CAMERA);
				cameraController.enableKeyListener();
				cameraController.updateCameraOrigin(90000, 170, 70000);

				rainController.init(scene);

				//draw line between v1 and v2 with color
				function lineDbg(v1, v2, dbgColor) {
					var mat = new THREE.LineBasicMaterial({color: dbgColor});
					var geometry = new THREE.Geometry();
					geometry.vertices.push( v1, v2 );

					var line = new THREE.Line( geometry, mat );
					scene.add( line );
				}

				//place sign at corresponding position
				function meshHelper(meshBuilder, node, prev) {
					var meshType = node.streetSign.type;
					var id = node.streetSign.id;
					var angle = 0;
					if(typeof prev != 'undefined') angle = -(Math.atan2(node.z - prev.z, node.x - prev.x) + 3/2*math.pi);
					switch(meshType) {
						case "EMPTY_SIGN":
							break;
						case "TRAFFIC_LIGHT":
							if(node.streetSign.one) meshBuilder.addTrafficLight( id, {x: node.streetSign.x1, y:0 , z: node.streetSign.z1}, {x:0, y:angle + math.pi, z:0} );
							if(node.streetSign.two) meshBuilder.addTrafficLight( id, {x: node.streetSign.x2, y:0 , z: node.streetSign.z2}, {x:0, y:angle, z:0} );
							break;
						case "EGG_SIGN":
							if(node.streetSign.one) meshBuilder.addEggSign( id, {x: node.streetSign.x1, y:0 , z: node.streetSign.z1}, {x:0, y:angle, z:0} );
							if(node.streetSign.two) meshBuilder.addEggSign( id, {x: node.streetSign.x2, y:0 , z: node.streetSign.z2}, {x:0, y:angle + math.pi, z:0} );
							break;
						case "INTERSECTION_SIGN":
							if(node.streetSign.one) meshBuilder.addIntersectionSign( id, {x: node.streetSign.x1, y:0 , z: node.streetSign.z1}, {x:0, y:angle, z:0} );
							if(node.streetSign.two) meshBuilder.addIntersectionSign( id, {x: node.streetSign.x2, y:0 , z: node.streetSign.z2}, {x:0, y:angle + math.pi, z:0} );
							break;
						case "STOP_SIGN":
							if(node.streetSign.one) meshBuilder.addStopSign( id, {x: node.streetSign.x1, y:0 , z: node.streetSign.z1}, {x:0, y:angle, z:0} );
							if(node.streetSign.two) meshBuilder.addStopSign( id, {x: node.streetSign.x2, y:0 , z: node.streetSign.z2}, {x:0, y:angle + math.pi, z:0} );
							break;
						case "PRIORITY_SIGN":
							if(node.streetSign.one) meshBuilder.addPrioritySign( id, {x: node.streetSign.x1, y:0 , z: node.streetSign.z1}, {x:0, y:angle, z:0} );
							if(node.streetSign.two) meshBuilder.addPrioritySign( id, {x: node.streetSign.x2, y:0 , z: node.streetSign.z2}, {x:0, y:angle + math.pi, z:0} );
							break;
						default:
							meshBuilder.addDummy( -2, {x: node.x, y: node.y, z: node.z}, {x:0, y:angle + math.pi, z:0} );
							break;
					}
					//show nodes and connections
					if(LS_Dbg) {
						if(node.streetSign.one) lineDbg({x: node.x, y: 40, z: node.z}, {x: node.streetSign.x1, y:40 , z: node.streetSign.z1}, 0xcc5c00);
						if(node.streetSign.two) lineDbg({x: node.x, y: 40, z: node.z}, {x: node.streetSign.x2, y:40 , z: node.streetSign.z2}, 0x0000ff);
						meshBuilder.addDummy( -2, {x: node.x, y: node.y, z: node.z}, {x:0, y:angle, z:0} );
					}

				}
                
				//ATTACH DATA HANDLERS
				//environment
				DataModel.addHandler(DataModel.STREETS_HANDLER, function streetsHandler(data, resolve, reject) {
                    //clear environment before building up the new one.
                    //It is IMPORTANT, that this handler is executed before any other (first added in DataModel handlers), otherwise the new environment might not be build completely
                    ENV_BUILDER.clear();
                    MESH_BUILDER.clear();
                    INIT_CAR = null; //reset followed car
                    //remove previous cars
                    for(var c in CARS) {
                        scene.remove(CARS[c].object);
                        carController.removeCar(c); //remove car from CarController
                    }
                    CARS = {}; //reset car list
                    
					var prevNode;
					for(var i=0; i<data.length; ++i) {
						//nodes for streets and signs
						for(var n=0; n<data[i].nodes.length; ++n) {
							var node = data[i].nodes[n];
							if(LS_Meshcounter < 200) {
								meshHelper(MESH_BUILDER, node, prevNode);
							}
							prevNode = {x: node.x, z: node.z};
                            
							data[i].nodes[n] = new THREE.Vector3(node.x, node.y, node.z);
						}
                        
						ENV_BUILDER.drawRoad(data[i].nodes, data[i].streetWidth);
					}
                    
          			resolve();
				});

				//map bounds (terrain)
				DataModel.addHandler(DataModel.BOUNDS_HANDLER, function terrainHandler(data, resolve, reject) {
					ENV_BUILDER.addTerrain(data);
					resolve();
				});

				//cars
				DataModel.addHandler(DataModel.CARS_HANDLER, function carsHandler(data, resolve, reject) {
                    var isCarListChanged = false;
                    
                    var remainingCars = [];
                    
					for(var i=0; i<data.length; ++i) {
                        var carExists = false;
                        //check if the car already exists
                        for(var c in CARS) {
                            if(carExists = (CARS[c].id === data[i].id)) break;
                        }

                        if(carExists) {
                            carController.handleData(data[i], resolve);
                        }else {
                            //fixed car type and material
                            data[i].type = "veyron";
                            data[i].material = 13;

                            CARS[data[i].id] = carBuilder.build(data[i].id, data[i].type, data[i].material, data[i].position, scene); //data .type and .material are currently undefined, so we get random values
                            
                            isCarListChanged = true;
                            //add car
                            carController.addCar(data[i].id, CARS[data[i].id]);
                            
                            window.setTimeout(resolve, 2000); //Some time to display the car
                        }
                        
                        //keep track of remaining cars
                        remainingCars.push("" + data[i].id);
					}
                    
                    if(remainingCars.length > 0) { //remove cars, only if there is at least one left to allow animation
                        //find missing cars
                        var toBeRemoved = [];
                        for(var c in CARS) 
                            if(remainingCars.indexOf(c) < 0) toBeRemoved.push(c);

                        //remove missing cars
                        for(var i=0; i<toBeRemoved.length; ++i) {
                            scene.remove(CARS[toBeRemoved[i]].object);
                            carController.removeCar(toBeRemoved[i]);
                            delete CARS[toBeRemoved[i]];
                        }
                        //update car list in nav bar
                        if(toBeRemoved.length > 0) isCarListChanged = true;
                    }
                    
                    let userVar = USER.getVariable("vehicle_id");
                    //set init car, when we have not done this before, there is a user variable for the car and the car has already been initialized (displayed)
                    if(!INIT_CAR && userVar && (CARS.hasOwnProperty(userVar.value))) {
                        INIT_CAR = userVar.value;
                        switchCar(INIT_CAR);
                    }else if(!currentCar && data.length > 0) switchCar(data[0].id);
                    
                    //update buttons
                    if(isCarListChanged) initCarButtons();
				});

				//rain
				DataModel.addHandler(DataModel.RAIN_HANDLER, function rainHandler(data, resolve, reject) {
					if(typeof carController.getCurrentCarObj() !== 'undefined') {
						var carPos = carController.getCurrentCarObj().model.root.position;
					}

					if(data) {
						rainController.startRaining(scene, carPos);
					} else {
						rainController.stopRaining(scene);
					}
					resolve();
				});

				//pedestrians
				DataModel.addHandler(DataModel.PEDESTRIANS_HANDLER, function pedestriansHandler(data, resolve, reject) {
					for(var i = 0; i < data.length; ++i) {
                        var pedestrianExists = false;
							for(var p in meshArr.pedestrians)
									if(pedestrianExists = (meshArr.pedestrians[p].projectID == data[i].id)) break;
                        if(pedestrianExists) {
                            // Compute rotation from positions
                            var diffX = (data[i].position.x - meshArr.pedestrians[p].position.x);
                            var diffY = (data[i].position.y - meshArr.pedestrians[p].position.y);
                            var diffZ = (data[i].position.z - meshArr.pedestrians[p].position.z);
                            
                            if (diffX != 0.0 || diffY != 0.0 || diffZ != 0.0)
                            {
                                var diffVector = new THREE.Vector3(diffX, diffY, diffZ);
                                var axisVector = new THREE.Vector3(0.0, 0.0, 1.0);
                                var angle = diffVector.angleTo(axisVector);
                                
                                if (diffX < 0.0) {
                                    angle = -angle;
                                }

                                meshArr.pedestrians[p].rotation.y = angle;
                            }

                            // Update position
                            meshArr.pedestrians[p].position.set( data[i].position.x, data[i].position.y, data[i].position.z );
                        }else {
                            MESH_BUILDER.addArnold(data[i].id, {x: data[i].position.x, y: data[i].position.y, z:data[i].position.z});
                        }
					}
					resolve();
				});

                // Static box objects
                DataModel.addHandler(DataModel.STATIC_BOX_OBJECT_HANDLER, function staticBoxObjectsHandler(data, resolve, reject) {
					for(var i = 0; i < data.length; ++i) {
                        // PHYSICAL_OBJECT_TYPE_TREE
                        if (data[i].objectType == 7)
                        {
                            MESH_BUILDER.addTreeStd(data[i].id, {x: data[i].position.x, y: data[i].position.y, z:data[i].position.z}, {x:0, y:0, z:0});
                        }
                        // PHYSICAL_OBJECT_TYPE_STREETLANTERN
                        else if (data[i].objectType == 8)
                        {
                            MESH_BUILDER.addStreetLamp(data[i].id, {x: data[i].position.x, y: data[i].position.y, z:data[i].position.z}, {x:0, y:0, z:0});
                        }
                        //PHYSICAL_OBJECT_TYPE_ROADWORKSIGN
                        else if (data[i].objectType == 9)
                        {
                            MESH_BUILDER.addCons(data[i].id, {x: data[i].position.x, y: data[i].position.y, z:data[i].position.z}, {x:0, y:0, z:0});
                        }
                        //PHYSICAL_OBJECT_TYPE_HOUSE
                        else if(data[i].objectType == 10)
                        {
                            MESH_BUILDER.addHouse(data[i].id, {x: data[i].position.x, y: data[i].position.y, z:data[i].position.z}, {x:0, y:0, z:0});
                        }
                        // PHYSICAL_OBJECT_TYPE_NETWORK_CELL_BASE_STATION
                        else if (data[i].objectType == 11)
                        {
                            var obj = new THREE.Mesh(new THREE.CubeGeometry(data[i].width * 100, data[i].height * 100, data[i].length * 100), new THREE.MeshLambertMaterial({color: 0x555555, side: THREE.DoubleSide}));
                            obj.position.x = data[i].position.x;
                            obj.position.y = data[i].position.y;
                            obj.position.z = data[i].position.z;
                            scene.add(obj);
                        }
                    }
                    resolve();
                });

                //execute command after each frame has been rendered
                DataModel.afterEachFrame = function doScreenshot() {
					// Disable sending of screenshots to server for now for WebSocket performance
					// Possibly wrong screenshots anyways?
					/*
					const carId = carController.getCurrentCar();
					const screenshot = getScreenshotAsImg(carId);
					WebService.WS_screenshot({	carId, screenshot });
					*/
				}
                
                //==========================================================================
                
                //init NavBar
                initNav();

				//==========================================================================

				// LIGHTS

				var ambient = new THREE.AmbientLight( 0xffffff, 2 );
				scene.add( ambient );

				directionalLight = new THREE.DirectionalLight( 0xffffff, 2  );
				directionalLight.position.set(0,1,1).normalize;
				// scene.add( directionalLight );

				hemiLight = new THREE.HemisphereLight( 0xffffff, 0xffffff, 0.2 );
				hemiLight.color.setHSL( 0.6, 0.75, 0.5 );
				hemiLight.groundColor.setHSL( 0.095, 0.5, 0.5 );
				hemiLight.position.set( 0, 500, 0 );
				// scene.add( hemiLight );


				// RENDERER

				renderer = new THREE.WebGLRenderer({ preserveDrawingBuffer: true, antialias: true, alpha: true });
				renderer.setPixelRatio( window.devicePixelRatio );
				renderer.setSize( window.innerWidth, window.innerHeight );
				renderer.setFaceCulling( THREE.CullFaceNone );
				renderer.setClearColor( 0x808080 );

				container.appendChild( renderer.domElement );
				
				// renderer for normal screenshots
				rendererH = new THREE.WebGLRenderer({preserveDrawingBuffer: true, antialias: true, canvas: hCanvas});
				rendererH.setPixelRatio( window.devicePixelRatio );
				rendererH.setSize( hCanvas.width, hCanvas.height );
				rendererH.setFaceCulling( THREE.CullFaceNone );
				rendererH.setClearColor( 0x808080 );

				container.appendChild( rendererH.domElement );

				// renderer for dashCam screenshots from cars
				rendererHLowRes = new THREE.WebGLRenderer({preserveDrawingBuffer: true, antialias: true, canvas: hCanvasLowRes});
				rendererHLowRes.setPixelRatio( window.devicePixelRatio );
				rendererHLowRes.setSize( hCanvasLowRes.width, hCanvasLowRes.height );
				rendererHLowRes.setFaceCulling( THREE.CullFaceNone );
				rendererHLowRes.setClearColor( 0x808080 );

				container.appendChild( rendererHLowRes.domElement );

				// stereo effect
				effect = new THREE.StereoEffect( renderer );
				effect.setSize( window.innerWidth, window.innerHeight );
				effect.setEyeSeparation(stereoCameraBaseline);

				// stereo effect for hidden LowRes canvas
				effectLowRes = new THREE.StereoEffect( rendererHLowRes );
				effectLowRes.setSize( hCanvasLowRes.width, hCanvasLowRes.height );
				effectLowRes.setEyeSeparation(stereoCameraBaseline);
				
				
				if ( STATS_ENABLED ) {

					stats = new Stats();
					container.appendChild( stats.dom );

				}

				document.addEventListener( 'mousemove', onDocumentMouseMove, false );

				window.addEventListener( 'resize', onWindowResize, false );
				document.addEventListener( 'keydown', onKeyDown, false );
			}
            
            //prepare server callbacks =========================
            var onScenarioLoaded = function onScenarioLoaded(res) {
                if(!res) return;
                
                //start animation after the environment is ready is processed
                if(!WebService.WS_isSimRunning()) DataModel.onDataProcessed = animate;
                //attach DataModel to WebSocket connection 
                WebService.WS_attachListener(DataModel.onData);
                //build world
                DataModel.onData(res);
            }
			
			var onSimulationReady = function onSimulationReady(duration)  {
				//hide loading screen
				$("loader").className = "disabled";
				//show message
                let sec = Math.round(duration/1000);
                let min = Math.floor(sec/60);
                sec -= 60*min;
                
                let message = (min > 0 ? min + "m " : "") + sec + "s.";
                
                $("message").innerHTML = "Simulation done for " + message + " Press play to start/resume simulation.";
                $("message").className = "";
                
                //update controls 
                NavBar([ 
                    { 
                        text: USER.name, 
                        clas: 'fa fa-user-circle' 
                    }, 
                    { 
                        text: 'Play', 
                        clas: 'fa fa-play', 
                        onClick: function play() { 
                            //disable orbit controls 
                            controls.enabled = false; 
                            $("message").className = "disabled";
                            WebService.WS_onUserUpdate(function updateUser(e) { USER = e.user; }); 
                            WebService.WS_start(); 
                        } 
                    }, 
                    { 
                        text: 'Back', 
                        clas: 'fa fa-step-backward', 
                        onClick: onStopClicked 
                    } 
                ], document.getElementById("nav-menu"), true); 
			}
			
            function onScenariosReady(scenarios) {
                //prepare scenarios as dropdown data
                let scenArr = [];
                for(let i=0; i<scenarios.length; ++i) {
                    let tracksArr = [];

                    for(let t=0; t<scenarios[i].tracks.length; ++t) {
                        tracksArr.push({
                            text: scenarios[i].tracks[t].name,
                            onClick: function loadScenario() {
                                $("loader").className = ""; //show loading screen
								WebService.WS_onSimulationReady(onSimulationReady);
								//request scenario
								WebService.WS_loadScenario(scenarios[i].id, scenarios[i].tracks[t].id, onScenarioLoaded);
                            }
                        });
                    }

                    scenArr.push({
                        text: scenarios[i].name,
                        items: tracksArr
                     });
                }

                //update controls
                NavBar([
                    {
                        text: USER.name,
                        clas: 'fa fa-user-circle'
                    },
                    {
                        text: 'Scenarios',
                        clas: 'fa fa-file-text',
                        items: scenArr
                    },
                    {
                        text: 'Upload Scenario',
                        clas: 'fa fa-upload',
                        id: 'upload', //container link
                        onClick: function triggerUpload() {
                            let link = document.getElementById("upload");
                            let upload = link.children[link.children.length-1];
                            upload.click();
                        }
                    },
                    {
                        text: 'Logout',
                        clas: 'fa fa-window-close',
                        onClick: function logout() {
                            WebService.WS_logout(initNav);
                        }
                    }
                ], document.getElementById("nav-menu"), true).then(function onNavBarReady() {
                    //create upload input after NavBar is ready
                    let upload = document.createElement("input");
                    upload.setAttribute("type", "file");
                    upload.setAttribute("multiple", "multiple");
                    
                    upload.onchange = function onChange(e) {
                        $("loader").className = ""; //show loading screen
                        WebService.WS_uploadScenario(e.target.files, function onUploadDone() {
                            $("loader").className = "disabled"; //hide loading screen
                        });
                    }
                    
                    //add to the uplaod link
                    document.getElementById("upload").appendChild(upload);
                });
            }

            function initNav() {
                NavBar([
                    {
                        text: 'login',
                        clas: 'fa fa-user-circle',
                        onClick: function () {
                            //login (as guest)
                            WebService.WS_login(null, null, function onSuccess(user) {
                                USER = user;
                                //fetch scenarios when user is logged in
                                WebService.WS_getScenarios(onScenariosReady);
                            });
                        }
                    }
                ], document.getElementById("nav-menu"), true);
            }
			
			//==========================================================================
            
            /**
            * Rebuild car buttons in navigation bar.
            */
			function initCarButtons() {
                var simCars = [];
                for(var car in CARS) {
                    simCars.push({
                        text: car,
                        onClick: function onCarSelected() {
                            console.log("Selected car: " + this.text);
                            if ( !CARS[ this.text ].root ) {
                                loader.load( CARS[ this.text ].url, function( geometry ) { createScene( geometry, this.text ) } );
                            } else {
                                switchCar( this.text );
                            }
                        }
                    });
                }
                
                //update controls
                NavBar([
                    {
                        text: USER.name,
                        clas: 'fa fa-user-circle'
                    },
                    {
                        text: 'Vehicles',
                        clas: 'fa fa-car',
                        items: simCars
                    },
                    {
                        text: 'Stop',
                        clas: 'fa fa-stop',
                        onClick: onStopClicked
                    }
                ], document.getElementById("nav-menu"), true);
			}
            
            function onStopClicked() {
                //stop simulation
                WebService.WS_stop(function onSectorLeave() {
                    //fetch scenarios again and build navigation bar
                    WebService.WS_getScenarios(onScenariosReady);
                });
            }

            //==========================================================================
            
			/**
			*	toggle some HUD elements
			*/ 
			function toggleHUD() {
				var HUD = ["nav-menu"];

				for(var i = 0; i<HUD.length; i++) {
					var display = document.getElementById(HUD[i]).style.display;
					if(display != "none") document.getElementById(HUD[i]).style.display="none";
					else document.getElementById(HUD[i]).style.display="block";
				}
			}
			
			/**
			*	move camera to position
			*	@param {int} x the x-coordinate to be set
			*	@param {int} y the y-coordinate to be set
			*	@param {int} z the z-coordinate to be set
			*/
			function goTo(x,y,z){
				camera.position.x = x;
				camera.position.y = y;
				camera.position.z = z;
			}

			/**
			*	set time
			*	@param {string} time day, night or circle to start/stop cycle
			*/
			function setTime(time) {
				switch(time) {
					case 'circle':
						dayNightCircle = true;
						directionalLight.visible = true;
						break;
					case 'day':
						dayNightCircle = false;
						directionalLight.visible = true;
						directionalLight.position.set(0,1,0).normalize;
						return "Praise the Sun!";
					case 'night':
						dayNightCircle = false;
						directionalLight.visible = false;
						return "Goodnight";
				}
			}

			function getHeightData(img,scale) {

				 if (scale == undefined) scale=1;

					var canvas = document.createElement( 'canvas' );
					canvas.width = img.width;
					canvas.height = img.height;
					var context = canvas.getContext( '2d' );

					var size = img.width * img.height;
					var data = new Float32Array( size );

					context.drawImage(img,0,0);

					for ( var i = 0; i < size; i ++ ) {
						data[i] = 0
					}

					var imgd = context.getImageData(0, 0, img.width, img.height);
					var pix = imgd.data;

					var j=0;
					for (var i = 0; i<pix.length; i +=4) {
						var all = pix[i]+pix[i+1]+pix[i+2];
						data[j++] = all*scale;
				}

				return data;
			}

			function getHeightForPosition(x,z)
			{
				var xnew = planeXVerts/planeX*x;
				var znew = planeZVerts/planeZ*z;


				var xnewf = math.floor(xnew);
				var znewf = math.floor(znew);
				/*
				var xnewc = math.ceil(xnew);
				var znewc =  math.ceil(znew);

				xnewc = (xnewc % planeXVerts == 0) ? xnewf : xnewc;
				znewc = (znewc % planeZVerts == 0) ? znewf : znewc;

				console.log(xnew);
				console.log(znew);
				var X = math.matrix([[xnewf, znewf, 1], [xnewf, znewc, 1],[xnewc, znewf, 1],[xnewc, znewc, 1]]);
				console.log(X);
				var r = math.matrix([[heightData[xnewf*planeZVerts+znewf]],[heightData[xnewf*planeZVerts+znewc]],[heightData[xnewc*planeZVerts+znewf]],[heightData[xnewc*planeZVerts+znewc]]]);
				console.log(r);
				var a= math.multiply(math.multiply(math.inv(math.multiply(math.transpose(X),X)),math.transpose(X)),r);
				height = math.multiply(math.transpose(a), math.matrix([[xnew], [znew],[1]]));
				return height;
				*/
				return heightData[xnewf+planeXVerts*znewf];
			}
			function onWindowResize() {

				windowHalfX = window.innerWidth / 2;
				windowHalfY = window.innerHeight / 2;

				camera.aspect = window.innerWidth / window.innerHeight;
				camera.updateProjectionMatrix();
				camera.projectionMatrix.scale(new THREE.Vector3(-1, 1, 1));
				
				hCamera.aspect = window.innerWidth / window.innerHeight;
				hCamera.updateProjectionMatrix();

				renderer.setSize( window.innerWidth, window.innerHeight );
				rendererH.setSize( window.innerWidth, window.innerHeight );

				effect.setSize( window.innerWidth, window.innerHeight );
			}

			/**
			*	save/download uri(screenshot) through browser
			*	(important to set preserveDrawingBuffer: true when initializing WebGLRenderer)
			*	@param {string} uri base64 string containing the screenshot
			*	@param {string} filename name the file gets
			*/
			function saveAsJPG(uri, filename) {
				  var link = document.createElement('a');
				  if (typeof link.download === 'string') {
					link.href = uri;
					link.download = filename;

					//Firefox requires the link to be in the body
					document.body.appendChild(link);

					//simulate click
					link.click();

					//remove the link when done
					document.body.removeChild(link);
				  } else {
					window.open(uri);
				  }
			}

			/**
			*	take screenshot from a given camera as .(type) file
			*	if given a carID returns a lowRes(600x300) stereo screenshot from a dashcam corresponding to carID
			*	(every car has its own THREE.camera)
			*	if stereo effect is enabled returns stereo screenshot from current view(regardless if a different camera is passed)
			*	
			*	@param {object/int} cam THREE.Camera/carID
			*	@param {string} type filetype of the image
			*/
			function takeScreenshot( cam, type='image/jpg'){
				var temp = screenIter.toString();
				for(var i = temp.length; i < 3; ++i) temp = "0" + temp;
                // relies on conscientious use of parameter cam
				if(!isNaN(cam)) {
					// cam is carID
					cameraController.updateCarCamera(CARS[cam], hCamera);
					
					// render picture
					effectLowRes.render( scene, hCamera );

					saveAsJPG( rendererHLowRes.domElement.toDataURL(type) , currentCar + "_" + temp + ".jpg" );
				} else {
					// cam is camera
					if (useStereo) {
						// render picture
						effect.render( scene, camera );
						saveAsJPG( renderer.domElement.toDataURL(type) , currentCar + "_" + temp + ".jpg" );
					} else {
						// render picture
						rendererH.render(scene, cam);
						saveAsJPG( rendererH.domElement.toDataURL(type) , currentCar + "_" + temp + ".jpg" );
					}
				}
				screenIter++;
			}

			/**
			*	returns base64 string of screenshot
			*	see takeScreenshot() for information about functionality
			*/
			function getScreenshotAsImg(cam, type='image/jpg') {
				if(!isNaN(cam)) {
					cameraController.updateCarCamera(CARS[cam], hCamera);
					effectLowRes.render( scene, hCamera );
					return rendererHLowRes.domElement.toDataURL(type);
				} else {
					if (useStereo) {
						effect.render( scene, camera );
						return renderer.domElement.toDataURL(type);
					} else {
						rendererH.render(scene, cam);
						return rendererH.domElement.toDataURL(type);
					}
				}
			}

			function genNegCarTrainingData( num ) {
				generateNegativeTrainingData(num, CARS, controls);
			}

			function $( id ) { return document.getElementById( id ) }
			function button_name( car, index ) { return "m_" + car  + "_" + index }

			function switchCar( car ) {
				for ( var c in CARS ) {

					if ( c != car && CARS[ c ].root ) {
						//CARS[ c ].object.visible = false;
						CARS[ car ].object.visible = true;
						//CARS[ c ].buttons.style.display = "none";

					}
				}


//				CARS[ car ].buttons.style.display = "block";

//				$( "car_name" ).innerHTML = CARS[ car ].name + " model";
//				$( "car_author" ).innerHTML = CARS[ car ].author;

				currentCar = car;
                carController.setCurrentCar(currentCar);

			}


			function onDocumentMouseMove(event) {

				mouseY = ( event.clientY - window.innerHeight );

			}

			function onKeyDown ( event ) {
				switch ( event.keyCode ) {
					case 80: // p
						takeScreenshot(camera);
						break;
					case 76: // l
						useStereo = !useStereo;
						onWindowResize();
						break;
					case 72: // h
						toggleHUD();
						break;
					case 85: // u
						controls.enabled = !controls.enabled;
						break;
				}
			}
			//

			function animate() {

                if (DataModel.simulationTimeDeltaMs > 0) {
                    setTimeout(function() {requestAnimationFrame(animate);}, DataModel.simulationTimeDeltaMs);
                } else {
                    requestAnimationFrame( animate );
                }
                
				controls.update();
				render();

			}

			// Rotate an object around an axis in world space (the axis passes through the object's position)

			function render() {
				timeDelta = clock.getDelta();
				var angle = 0.01;
				currentCar = carController.getCurrentCar()
				if(dayNightCircle) {
					if(!isNaN(directionalLight.position.x) && !isNaN(directionalLight.position.z) && !isNaN(angle)) {
						var currentX = directionalLight.position.x;
						var currentY = directionalLight.position.y;
						directionalLight.position.x = currentX * Math.cos(angle) - currentY * Math.sin(angle);
						directionalLight.position.y = currentY * Math.cos(angle) + currentX * Math.sin(angle);

						// ** TURN LIGHTS ON BASED ON SUN POSITION **
						currentCarObj = carController.getCurrentCarObj();
						if(typeof currentCarObj !== 'undefined' && currentCarObj.backLight !== null) {
								if(directionalLight.position.y < 0) {
									//Then its dark -> turn on the lights of the current car
									currentCarObj.lightController.turnLightsOn(currentCarObj);
								} else {
									//Then its bright -> turn off the lights of the current car
									currentCarObj.lightController.turnLightsOff(currentCarObj);
								}
						}
					}
				}

				for (var car in CARS) {
  					if (CARS.hasOwnProperty(car) && CARS[car]!=null) {
					  	// or if (Object.prototype.hasOwnProperty.call(obj,prop)) for safety...
						if(car==currentCar){
							if(!controls.enabled) {
								carController.update(timeDelta);
								cameraController.update();

								if(cameraController.getCurrentCamera().startsWith("birdseye")) camera.rotation.set(-0.5 * Math.PI, 0.0, -Math.PI)
								else if(cameraController.getCurrentCamera() !== 'dashCam') camera.lookAt(CARS[currentCar].position)
								else camera.lookAt(CARS[currentCar].object.localToWorld(new THREE.Vector3( 0, 0, 500) )  )
							}
						}
					}
				}

				if(!controls.enabled) {
					if(typeof CARS == 'undefined' || Object.keys(CARS).length === undefined || CARS.length == 0) camera.lookAt(new THREE.Vector3( 90000,  50, 72000));
				}

				if(rainController.isItRaining()) {
					rainController.simulateRain();
				}

				if (useStereo) {
					effect.render( scene, camera );
				}
				else {
					renderer.render(scene, camera);
				}

				if ( STATS_ENABLED ) stats.update();

			}

			function updateCarPose(x,y,z,theta)
			{
				currentCarObj = CARS[currentCar].object;

				currentCarObj.position.x += x;
				currentCarObj.position.y += y;
				currentCarObj.position.z += z;

				currentCarObj.rotateX(theta.x);
				currentCarObj.rotateY(theta.y);
				currentCarObj.rotateZ(theta.z);

        		renderer.render(scene, camera)

				cameraController.updateRelativeCameraPosition();
			}
</script>
</body>
</html>
